"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _call = require("../methods/call.js");

/**
 * Copyright (c) 2017-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

/*  strict-local */
// ECMA262 12.3.7
function _default(ast, strictCode, env, realm) {
  // 1. Let tagRef be the result of evaluating MemberExpression.
  let tagRef = env.evaluate(ast.tag, strictCode); // 2. Let thisCall be this MemberExpression.
  // 3. Let tailCall be IsInTailPosition(thisCall).
  // 4. Return ? EvaluateCall(tagRef, TemplateLiteral, tailCall).

  return (0, _call.EvaluateCall)(realm, strictCode, env, tagRef, ast.quasi);
}
//# sourceMappingURL=TaggedTemplateExpression.js.map